TYPE QTriLed EXTENDS QCANVAS
    RedState AS BYTE
    GreenState AS BYTE
    BlueState AS BYTE
    Size AS BYTE

    CONSTRUCTOR
        Size = 8
        Redstate = 1
        Greenstate = 1
        Bluestate = 1
    END CONSTRUCTOR

    SUB DrawLed
        DIM c AS INTEGER
        if QTriLed.RedState<>0 then QTriLed.RedState=1
        if QTriLed.GreenState<>0 then QTriLed.GreenState=1
        if QTriLed.BlueState<>0 then QTriLed.BlueState=1
        
        QTriLed.Width = QTriLed.Size
        QTriLed.Height = QTriLed.Size
        c = rgb(255*QTriLed.RedState,255*QTriLed.GreenState,255*QTriLed.BlueState)

        QTriLed.Circle(0 , 0 , QTriLed.Size , QTriLed.Size , 0 , c)
    END SUB

    EVENT OnPaint
        QTriLed.DrawLed
    END EVENT

    sub SetStates(r as Byte, g as Byte, b as Byte)
        QTriLed.RedState = r
        QTriLed.GreenState = g
        QTriLed.BlueState = b
        QTriLed.DrawLed
    end sub
    
    SUB SetRedState(s AS BYTE)
        QTriLed.RedState=s
        QTriLed.DrawLed
    END SUB
    
    SUB SetGreenState(s AS BYTE)
        QTriLed.GreenState=s
        QTriLed.DrawLed
    END SUB
    
    SUB SetBlueState(s AS BYTE)
        QTriLed.BlueState=s
        QTriLed.DrawLed
    END SUB
    
    Function GeStates as byte
        Result=QTriLed.RedState*100+QTriLed.GreenState*10+QTriLed.BlueState
    end Sub
    
    Function GetredState as byte
        Result=QTriLed.RedState
    end Sub
    
    Function GetGreenState as byte
        Result=QTriLed.GreenState
    end Sub
    
    Function GetBlueState as byte
        Result=QTriLed.BlueState
    end Sub
    
    SUB SetSize(s AS BYTE)
        QTriLed.Size = s
        QTriLed.DrawLed
    END SUB

    Function GetSize as byte
        Result=QTriLed.Size
    end Sub

    SUB ToggleRed
        QTriLed.RedState = abs(QTriLed.RedState-1)
        QTriLed.DrawLed
    END SUB

    SUB ToggleGreen
        QTriLed.GreenState = abs(QTriLed.GreenState-1)
        QTriLed.DrawLed
    END SUB

    SUB ToggleBlue
        QTriLed.BlueState = abs(QTriLed.BlueState-1)
        QTriLed.DrawLed
    END SUB

END TYPE


